(function($)
{
    var myStyle = [
        {
          "featureType": "landscape",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "poi",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "road",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "transit",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "water",
          "stylers": [
            { "visibility": "simplified" }
          ]
        },{
          "featureType": "administrative",
          "elementType": "all",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "landscape",
          "stylers": [
            { "color": "#333333" },
            { "visibility": "simplified" }
          ]
        },{
         "featureType": "water",
         "stylers": [
           { "visibility": "simplified" },
           { "color": "#333333" }
        ]
        }
    ];
    
    var myStyle2 = [
        {
          "featureType": "poi",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "road",
          "elementType": "geometry",
          "stylers": [
            { "visibility": "simplified" },
            { "color": "#333333" }
          ]
        },{
          "featureType": "road",
          "elementType": "labels.text.fill",
          "stylers": [
            { "color": "#ffffff" }
          ]
        },{
          "featureType": "road",
          "elementType": "labels.text.stroke",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "road",
          "elementType": "labels.icon",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "transit",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "water",
          "stylers": [
            { "visibility": "simplified" }
          ]
        },{
          "featureType": "administrative",
          "elementType": "all",
          "stylers": [
            { "visibility": "off" }
          ]
        },{
          "featureType": "landscape",
          "stylers": [
            { "color": "#808080" },
            { "visibility": "simplified" }
          ]
        },{
         "featureType": "water",
         "stylers": [
           { "visibility": "simplified" },
           { "color": "#333333" }
        ]
        }
    ];
    
    $(document).ready(function (){
        
        $('html body').css({width:$(window).width(), height:$(window).height()});
          
        var map;
        
        var bulletUrl = 'media/bullet.png';
        var size = 10;

        if(navigator.platform=='iPad' || navigator.userAgent.toLowerCase().indexOf('android')!=-1)
        {
            bulletUrl = 'media/bulletMidSmall.png';
            size = 20;
        }
        
        var disableDoubleClickZoom = true;
        if (navigator.appVersion.indexOf("MSIE 7.") != -1){
            disableDoubleClickZoom = false;
        }
  
        jQuery.initialize = function initialize(startZoom,startC,qType) {

            map = new google.maps.Map(document.getElementById('map-canvas'), {
                mapTypeControlOptions: {
                    mapTypeIds: ['mystyle', google.maps.MapTypeId.ROADMAP]
                },
                center: startC,
                zoom: startZoom,
                minZoom: 3,
                mapTypeId: 'mystyle',
                disableDefaultUI: true,
                zoomControl: true,
                disableDoubleClickZoom: disableDoubleClickZoom,
                zoomControlOptions: {
                    style: google.maps.ZoomControlStyle.SMALL,
                    position: google.maps.ControlPosition.RIGHT_CENTER
                }
            });


            if (navigator.appVersion.indexOf("MSIE 7.") != -1){
                map.mapTypes.set('mystyle', new google.maps.StyledMapType(myStyle2, {
                    name: 'My Style2'
                }));
            }
            else
            {
                map.mapTypes.set('mystyle', new google.maps.StyledMapType(myStyle, {
                    name: 'My Style'
                }));
            }
                        
            var image = new google.maps.MarkerImage(bulletUrl,
                new google.maps.Size(size, size)
            );
            
            var q;
            if(qType=='IT'){
                q = {select: 'geometry', from: '1Huogp8gP39ujZlwJRs9kzgfedHdE8OzBEB9Hl04'};
                map.setOptions({minZoom:6});
            }
            else
            {
                q = {select: 'geometry', from: '17mMrmy5DaEPNlPabZeKrTmY3e8cP7-qCFrrFyxk'};
//                q = {select: 'geometry', from: '1uL8KJV0bMb7A8-SkrIe0ko2DMtSypHX52DatEE4'};
//                q = {select: 'geometry', from: '1tv_FBqVJNF2q0yqZJiS1YAw3kpNDsfifBtQp7ns'};
                map.setOptions({minZoom:4});
            }
                
            var borderLayer = new google.maps.FusionTablesLayer({
                options : {suppressInfoWindows:true},
                query: q,
                styles: [
                    {
                        polygonOptions: {
                            fillColor:'#ffffff',
                            fillOpacity:.1,
                            strokeColor:'#ffffff',
                            strokeOpacity:.1
                        }
                    }
                ]
            });
            borderLayer.setMap(map);
            
//            $.ajax("ajax/fetchStoreData", {
//                type: 'POST',
//                dataType: 'json',
//                data: 'queryType='+qType,
//                success: function(data) {
//                    for(i in data){
//                        
//                        var latlng = new google.maps.LatLng(parseFloat(data[i].Lat), parseFloat(data[i].Lon));
//                        var h1 = data[i].Tipologia;
//                        
//                        var txt = '';
//                        //if(data[i].Tipologia!='' && data[i].Tipologia!=null){txt += data[i].Tipologia+'<br/>'};
//                        txt += '<strong>'+data[i].Stato+'</strong><br/>'+data[i].Citta+'<br/><p>';
//                        if(data[i].Indirizzo!='' && data[i].Indirizzo!=null){txt += data[i].Indirizzo};
//                        if(data[i].Note!='' && data[i].Note!=null){txt += '<br/>'+data[i].Note.replace(',', '')};
//                        if(data[i].Distretto!='' && data[i].Distretto!=null){txt += '<br/>'+data[i].Distretto.replace(',', '')};
//                        if(data[i].Shop!='' && data[i].Shop!=null){txt += '<br/>'+data[i].Shop.replace(',', '')};
//                        txt+='</p>';
//                        
//                        var marker = new google.maps.Marker({
//                            map: map,
//                            position: latlng,
//                            icon: image,
//                            title: h1,
//                            text: txt
//                        });
//
//                        google.maps.event.addListener(marker, 'click', function() {
//
//                            $('#storeInfo').removeClass('hide');
//                            $('#storeInfo h1').text(this.title);
//                            $('#storeData').html(this.text);
//
//                        });
////                        var adr = data[i].Indirizzo+', '+data[i].Citta+', '+data[i].Regione;
////                        console.log(adr);
////                        Geocode(adr,map,image);
//                        
//                    }
//                },
//                error: function() {
//                    // Show some error message, couldn't get the CSV file
//                }
//            });
            
            google.maps.event.addListener(map, 'zoom_changed', function(){
                $('#storeInfo').addClass('hide');
                google.maps.event.addListenerOnce(map, 'tilesloaded', function(){
                    if(map.zoom>9 || navigator.appVersion.indexOf("MSIE 7.") != -1){
                        map.mapTypes.set('mystyle', new google.maps.StyledMapType(myStyle2, {
                            name: 'My Style2'
                        }));
                    }
                    else
                    {
                        map.mapTypes.set('mystyle', new google.maps.StyledMapType(myStyle, {
                            name: 'My Style'
                        }));
                    }
                });
            });
            
            var allowedBoundsIT = new google.maps.LatLngBounds(
                new google.maps.LatLng(34.597042,-6.811523), 
                new google.maps.LatLng(48.618385,26.520996)
            );
            var allowedBoundsW = new google.maps.LatLngBounds(
                new google.maps.LatLng(-50.064192,-147.65625), 
                new google.maps.LatLng(70.495574,138.164063)
            );
            var allowedBounds;
                
            if(qType=='IT'){allowedBounds=allowedBoundsIT;}else{allowedBounds=allowedBoundsW;}
            
            var lastValidCenter = map.getCenter();

            google.maps.event.addListener(map, 'center_changed', function() {
                if (allowedBounds.contains(map.getCenter())) {
                    // still within valid bounds, so save the last valid position
                    lastValidCenter = map.getCenter();
                    return; 
                }
                // not valid anymore => return to last valid position
                map.panTo(lastValidCenter);
            });
            
            google.maps.event.addDomListener(window, 'resize', function() {
                map.setCenter(startC);
            });
            
        }
        
        //var cW = new google.maps.LatLng(33.797409,54.667969);
        var cW = new google.maps.LatLng(35.694866,11.723633);
        var cIT = new google.maps.LatLng(41.409776,10.898438);
        
        google.maps.event.addDomListener(window, 'load', $.initialize(6, cIT, 'IT'));
   
        $('#interface').fadeIn('fast');

        var swTop = ($('#interface').height()-$('#switches').height())/2+'px';
        $('#switches').css({top:swTop});
        $('#italy').css({backgroundPosition:'0 0', color:'#fff'});
        
        $('#backTo').click(function(){
            location.href='/';
        })
        
        $('#logoGeo').click(function(){
            location.href='/';
        })
        
        $('#italy').click(function(){
            $('#storeInfo').addClass('hide');
            $.initialize(6, cIT, 'IT');
            $(this).css({backgroundPosition:'0 0', color:'#fff'});
            $('#world').css({backgroundPosition:'0 -46px', color:'#333333'});
        })
        
        $('#world').click(function(){
            $('#storeInfo').addClass('hide');
            $.initialize(4, cW, 'W');
            $(this).css({backgroundPosition:'0 0', color:'#fff'});
            $('#italy').css({backgroundPosition:'0 -46px', color:'#333333'});
        })
        
        function pdfOver(){
            $(this).find('a').css({color:'#fff'});
            $(this).css({backgroundPosition:'0 -25px'});
        }
        function pdfOut(){
            $(this).find('a').css({color:'#333333'})
            $(this).css({backgroundPosition:'0 0px'});
        }
        $('#pdf').hover(pdfOver, pdfOut);
        
    });

$(window).load(function() {
    $('#wrapper').css({opacity:'1'});
});

$(window).resize(function() {
    $('html, body').css({width:$(window).width(), height:$(window).height()});
    var swTop = ($('#interface').height()-$('#switches').height())/2+'px';
    $('#switches').css({top:swTop});
    $('#storeInfo').addClass('hide');
});

function onResize(){
//    $('#italy').css({backgroundPosition:'0 0', color:'#fff'});
//    $('#world').css({backgroundPosition:'0 -46px', color:'#333333'});
//    $.initialize(6, new google.maps.LatLng(41.409776,10.898438), 'IT');
    
}

var timer;
$(window).bind('resize', function(){
   timer && clearTimeout(timer);
   timer = setTimeout(onResize, 2000);
});

})(window.jQuery);

//function Geocode(address,m,i) {
//    var geocoder = new google.maps.Geocoder();
//    
//    geocoder.geocode({
//        'address': address
//    }, function(results, status) {
//        if (status === google.maps.GeocoderStatus.OK) {
//            
////            console.log('"'+results[0].formatted_address+'","'+results[0].geometry.location.Ya+'","'+results[0].geometry.location.Za+'"');
////            console.log('"'+address+'","'+results[0].geometry.location.Ya+'","'+results[0].geometry.location.Za+'"');
//            
//            var marker = new google.maps.Marker({
//                map: m,
//                position: results[0].geometry.location,
//                icon: i,
//                title: results[0].formatted_address
//            });
//
//            google.maps.event.addListener(marker, 'click', function() {
//                if($('#storeInfo').hasClass('hide')){$('#storeInfo').fadeIn('slow')}
//                $('#storeData').text(this.title);
//                m.setZoom(11);
//                m.panTo(this.position);
//            });
//            
//        } else if (status === google.maps.GeocoderStatus.OVER_QUERY_LIMIT) {    
//            setTimeout(function() {
//                Geocode(address,m,i);
//            }, 20);
//        } else {
//            console.log("Geocode was not successful for the following reason:"+ status);
//        }
//    });
//    
//}